<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">

<HTML>

<HEAD>
<TITLE>Cours/TD - résumé 3</TITLE>
<META NAME="GENERATOR" CONTENT="Arachnophilia 3.9">
<META NAME="FORMATTER" CONTENT="Arachnophilia 3.9">
<link REL="StyleSheet" TYPE="text/css" HREF="Costyle.css">

</HEAD>


<BODY BACKGROUND="../icons/brick.jpg">

<CENTER><H1>Cours/TD - résumé (3)</H1>
</CENTER>
<P>
<p>


<TABLE width=100%>
 <TR><TD align=left><A HREF="comres2.html"><IMG SRC="../icons/gb_larr.gif" border=0 align=absmiddle></A></TD>
<TD align=right><A HREF="comres4.html"><IMG SRC="../icons/gb_rarr.gif" border=0 align=absmiddle></A></TD>
</TR>
</TABLE>
<p>
<FONT COLOR=#0000FF FACE="Helvetica,Arial" point-size=14pt>

<H3><FONT COLOR=#f00000>26.10.99</FONT></H3>
<p>


<H2>Cours</H2>

La partie essentielle du compilateur - naturellement - c'est le générateur du code, même si souvent un cours de compilation consacre beaucoup d'attention à l'analyse, à la formation des items lexicaux (symboles, tokens) et ensuite à la formation des arbres syntaxiques. Le code doit être efficace, linéaire si possible - sans pointeurs inutiles, placé dans un vecteur plutôt que dans une liste, mais nous sommes en train de faire des maquettes. Il doit être également efficace sur le plan algorithmique : éviter la récursivité inutile (encombrement de la pile), création des ordures dans le tas système, etc. Mais nous avons commencé par la discussion de la machine qui interprète des arborescences syntaxiques. <p>

<H3>Parcours des arbres syntaxiques et son optimisation</H3><P>

Rappelons l'évaluateur de base : <I>Si l'expression est une feuille, évaluer la feuille par un mécanisme plus primitif, sinon <B>a.</B> évaluer toutes les branches (opérandes) et <B>b.</B> Appliquer l'opérateur</I>. Si on remplace l'évaluation, donc la création de la valeur finale, par la création d'un code intermédiaire, postfixe, on obtient "presque" un compilateur. Si - symboliquement  - la structure de données qui représente l'arbre syntaxique est de type :
<PRE>
data Arbre = L Value | N Op Arbre Arbre
</PRE><P>
où <TT>L</TT> est la balise qui identifie les feuilles (<I>leaves</I>), <TT>N</TT> - le noeud intermédiaire, <TT>Op</TT> est le type d'opérateurs, et <TT>Value</TT> - le type de valeurs, la linéarisation du code sera
<PRE>
comp (L x) = [x]
comp (N op ga dr) = comp ga ++ comp dr ++ [op]
</PRE><P>
où les simplifications sont les suivantes :
<OL>
<LI> Seulement opérateurs binaires. Le cas général est facile à traiter, il faut mettre dans le noeud une <I>liste</I> d'arguments, (elle peut être vide), et faire une boucle qui compile et concatène toutes les branches de cet arbre n-aire. <B>(Faire cet exercice !)</B>
<p>

<LI> On considère que les feuilles et les opérateurs appartiennent au même type (ce qui permet de les mettre dans une liste) - par exemple des chaînes. Un langage dynamiquement typé, p. ex. Lisp, serait "plus commode", car là les listes peuvent être hétérogènes ; ici il faut réfléchir un peu, mais le typage fort peut nous aider à discipliner le processus de compilation. En effet, quel avantage de pouvoir mettre n'importe quoi dans le code? Pour que la machine virtuelle qui va l'exécuter soit obligé d'analyser ces objets, de décoder les symboles, etc.? Non, si on veut le code final plus efficace, il faut effectuer une coercition - transformer les chaînes numériques, les symboles des variables, etc. en objets plus homogènes : les <B>items de code</B>, qui seront discutés en détails prochaînement.

</OL><P>
<a name="codstruct"></a>
Pour l'instant laissons en paix les données gérées par notre "générateur de code", mais optimisons sa structure. L'arbre <TT>x=3*x+2/x</TT> ou
<PRE>
         =
       /   \
      x     +
          /   \
         *     div
        / \    / \
       3   x  2   x
</PRE>
deviendra <TT>[x 3 x * 2 x / + =]</TT> sans aucune modification. (Tout le monde comprend pourquoi le slash a été remplacé par <TT>div</TT> dans la représentation graphique de l'arbre, n'est-ce pas?...)<p>

Le programme est récursif en cascade, avec la concaténation intercalée, ce qui génère de nombreuses listes intermédiaires (comme l'aplâtissement d'un arbre dans la procédure de tri arborescent sans optimisation, ou même dans la variante naïve d'inversion d'une liste). Ceci doit être également optimisé, car le compilateur qui est trop lent et gourmand, n'est pas utile, même s'il génère un bon code. Utilisons la technique classique d'optimisation des procédures récursives avec l'introduction d'un argument tampon. Construisons la fonction <TT>comp_s</TT>, dont la sémantique est la suivante :
<PRE style="color:#f00000">
comp_s arg tmp = (comp arg) ++ tmp
</PRE><P>
<span class=bl>(Ceci n'est pas sa vraie définition ! C'est <TT>comp</TT> qui sera définie par <TT>comp_s</TT>.)</span>
<p>

Voici la procédure qui linéarise les arborescences :
<PRE>
comp x = comp_s x [] where
 comp_s (L x) tmp = x : tmp
 comp_s (N op ga dr) tmp =
        comp_s ga (comp_s dr (op:tmp))
</PRE><P>
On ne peut supprimer ici complètement la récursivité en faveur des itérations (récursivité terminale ou boucle), ceci n'est pas notre objectif. Le code compilé, et exécuté ensuite par la machine à pile ne sera plus récursif. Pour le compilateur le gain est évident - il n'y a plus de création des listes intermédiaires. <p>

<p>
<CENTER><IMG SRC="../icons/barc.gif">
</CENTER>
<p>


<H3>Structure des feuilles ; environnements</H3>

Évaluation ou génération du code postfixe doit être complétée par la gestion des valeurs stockées dans les feuilles. Nous avons volontairement rapproché l'évaluateur, et le générateur de code, et il faut savoir que si ce dernier est simpliste et n'optimise pas les objets crées, l'exécution du programme sera plus onéreuse et vice-versa. Pour les petits interprètes embarqués dans une application, qui compilent et exécutent sur place des courtes expressions, (normalement : une seule fois, sans trop d'itérations), l'optimisation est inutile, voire nuisible, car augmente la taille du compilateur. Mais si nous décidons quand même d'effectuer un prétraitement optimisant du code, <B>indispensable</B> pour un compilateur plus ambitieux, il faudra penser à :
<OL>
<LI> Décodage des chaînes. Une constante numérique "3401" doit être transformé en nombre 3401, et normalement ceci est effectué <I>avant</I> la création de l'arborescence syntaxique, lors de l'analyse lexicale.
<p>

<LI> De même, un symbole, p. ex. "alpha" ne doit pas figurer dans le code comme une chaîne, mais l'analyseur doit créer un objet irréductible, un <B>atome</B> <TT>alpha</TT> stocké dans un <EM>tableau de symboles</EM>, et associé avec sa valeur (statique ou dynamique). Encore une fois, le module analysant en créant l'arbre syntaxique doit gérér en même temps l'environnement <A HREF="comres1.html#environ">mentionné précédemment</A>. (D'ailleurs, nous avons évoqué le fait qu'une affectation : <TT>x=y+2*x</TT> interprète le "x" à gauche non pas comme une valeur, mais comme une cible adressable. Mais la notion d'adresse est floue, et trop concrète en même temps... Est-ce une adresse statique, ou sur une pile locale? Donc, pour l'instant évitons d'utiliser ce mot, et parlons simplement de l'<EM>association variable-valeur</EM>.) Chaque occurence d'un symbole (dans le même contexte) dans le programme doit durant la création de l'arbre, se transformer en référence à la même association.
<P>


<LI> Mais le même symbole peut se trouver dans des contextes différents, par exemple un appel récursif peut accéder à une autre instance de la même variable. Il faut donc séparer la notion d'atôme et sa représentation externe - la chaîne. Il nous faudra maintenir l'environnement sous forme de pile. Ce sera discuté prochaînement.
<P>


<LI> Finalement, si on utilise un langage typé pour la construction de nos modules, il faut prévoir un moyen de mettre plusieurs types d'objets sous le même chapeau, pour pouvoir définir le type <TT>Value</TT>
</OL><P>

Nous allons donc construire une table de symboles relativement riche et complexe un peu plus tard, et dans le code tout symbole "alpha" etc. peut être finalement transformé en <EM>indice</EM> dans le tableau-environnement. <EM>Provisoirement</EM> on peut définir une feuille par les types suivants :
<PRE>
type Ind = Int    -- (le type d'indices abstrait)
data Value=Void|I Int|F Double|V Ind|C Code |...
...
</PRE>
avec un type "bidon" qui correspond aux objets <B>void</B> (p. ex. une structure impérative), les constantes entières ou flottantes, les variables, et les objets fonctionnels/procéduraux, qui seront spécifiés plus tard. Maintenant nous pouvons essayer d'écrire nos premières maquettes d'évalueteurs ou optimiseurs des feuilles, mais pour l'instant il n'y a presque rien d'intéressant ici.

<H3>Gestion des erreurs</H3>

Il faudra néanmoins pouvoir répondre à la question suivante : et si on divise par zéro? Malheuresement quand on construit une machine virtuelle et son compilateur, il faut traiter explicitement <EM>tout</EM>, y compris les exceptions, sauf si on s'arrête au niveau où ces exceptions sont prises en charge par la MV sous-jacente (les librariries <I>run-time</I> du C++, etc.) Voici une proposition simple (étendue plus tard), mais réaliste. Les Valeurs seront "emballées" par une structure composite plus large, dont la définition (appartenant d'ailleurs à la librarire standard de Haskell) peut être :
<PRE>
data Maybe a = Nothing | Just a
</PRE>
pour tout type <TT>a</TT>. Pour nous :
<PRE>
type Val = Maybe Value
</PRE>
et il faudra faire le "lifting" (augmentation de la sémantique) de <EM>toutes</EM> les fonctions qui manipulent les valeurs. <TT>Nothing</TT> est un <I>tag</I> qui dénote : "pas de réponse, erreur!", et ce n'est pas le même objet que <TT>Void</TT>.
L'expression <TT>Just x</TT> signifie "x tout court", mais avec une balise supplémentaire, permettant de distinguer les expressions légitimes et les bogues.<p>

À présent, toute fonction <TT>f :: Value -&gt; Value</TT>, qui transforme une valeur en une autre, doit être "liftée" par le combinateur <TT>errlift</TT> en <TT>f_er</TT>, dont la sémantique est la suivante :
<PRE>
f_er Nothing = Nothing
f_er (Just x) = Just (f x)
</PRE>
Cette transformation :
<PRE>
errlift f Nothing = Nothing
errlift f (Just x) = Just (f x)
</PRE>
pourrait être ajoutée à notre code <EM>automatiquement</EM>, le programmeur définit ses fonctions sans se soucier des erreurs, et le compilateur génère un code qui permet leur propagation. Pour les opérateurs binaires nous aurions
<PRE>
errop op Nothing _ = Nothing
errop op _ Nothing = Nothing
errop op (Just x) (Just y) = Just (op x y)
</PRE>
... mais ceci ne marchera pas toujours, seulement pour les fonctions qui sont "sûres" elles-mêmes ! Naturellement, parfois il faudra générer une erreur, et pas seulement le propager. Qu'est-ce passera-t-il si <TT>f</TT> (ou <TT>op</TT>) "bombe"? On ne peut pas transformer le résultat à <TT>Just ...</TT> La division sera définie plus ou moins comme :
<PRE>
...
div_er (Just x) (Just y) | y==0 = Nothing
                         | otherwise = x/y
</PRE>
La solution complète est donc <I>un peu</I> plus complexe (et il serait préférable de pouvoir tracer, c'est-à-dire paramétrer le diagnostic ; informer le programmeur que c'est la division qui a déclenché l'exception, et rien d'autre). Nous allons discuter cela prochaînement.


<!-- ********************************************************* --><p>
<CENTER><IMG SRC="../icons/limarro.gif" WIDTH="576" HEIGHT="9" ALT="">
</CENTER>
<p>

<p>
<H2>TD</H2>
<p>
<H3>Introduction à PostScript</H3>
<p>

Une façon possible de comprendre le fonctionnement d'une machine virtuelle de bas niveau, serait d'écrire quelques programmes de bas niveau, pour une machine à pile. Nous avons donc écrit quelques programmes en PostScript, qui est un langage parfaitement respectable, même s'il n'a pas été conçu pour la programmation humaine, mais pour le pilotage des imprimantes. Vous pouvez le tester intéractivement en utilisant l'interprète GhostScript, disponible sur toutes les plates-formes. <p>


En PS dans un programme nous avons les constantes numériques qui sont traitées comme les commandes "empiler" (de la constante en question). Autres symboles sont "exécutés", mais si le décodage d'un symbole montre qu'il spécifie une valeur numérique, une simple donnée, alors  il est traité comme une variable qui sera empilée. Ceci signifie que les objets en PostScripts sont "balisés", identifiables pendant l'exécution. Ceci simplifie <i>énormement</i> la compilation, et ralentit l'exécution. Voici un simple "programme" PS :
<PRE>
GS&gt;2 3 mul
GS&lt;1&gt;=
6
</PRE><P>


Deux nombres sont empilés, et multipliés. Le résultat est stocké sur la pile, et peut être affiché par "<TT>=</TT>", ou par la commande <TT>pstack</TT> qui affiche la totalité de la pile sans la détruire. Exemple de définition d'une variable, et son usage :
<PRE>
GS&gt;/pi 3.1416 def
GS&gt;pi 20 div =
0.15708
GS&gt;
</PRE><P>

Le slash identifie une <EM>constante littérale</EM>, un symbole, ou atome, une simple donnée alphanumérique. Le symbole <TT>pi</TT> dont le nom extérieur est <TT>/pi</TT> sera empilé. La valeur numérique sera empilée. La procédure primitive <TT>def</TT> retire de la pile un symbole et un objet quelconque, et forme l'association entre le symbole et cette valeur. Ensuite nous pouvons l'utiliser, ou rédéfinir. Une telle variable est globale.<p>

Le caractère acolade ouvrante : <TT>{</TT> est un opérateur qui change le régime de travail de l'interprète, au lieu d'exécuter les symboles, il les ramasse et stocke dans un tableau qui est complété après la lecture de <TT>}</TT>. Ce tableau est <EM>un objet procédural</EM>, une donnée, qui est empilée, et qui peut être associée avec un symbole. L'exécution de ce symbole est : exécuter le contenu de la procédure .<p>


Construisons une procédure qui calcule le cube d'un nombre. Il nous faudra un certain nombre de fonctions primitives, comme les opérations arithmétiques standard : <TT>add, sub, mul, div</TT>, et une opération de gestion de la pile. <TT>dup</TT> qui duplique (empile) le dernier objet déjà sur la pile. Voici la définition :
<PRE>
/cube {dup dup mul mul} def
</PRE><P>

Nous ne pouvons inclure dans ces notes la documentation du PostScript. Une liste abrégée de procédures primitives peut néanmoins nous être utile. Introduisons ici le minimum.
<UL>
<LI> Il existe un nombre de procédures de manipulation de la pile des données. Nous connaissons déjà <TT>dup</TT>. La commande <TT>pop</TT> dépile et supprime le dernier élément, et <TT>exch</TT> - échange les deux derniers éléments. Une commande utile et universelle : <TT>index</TT> permet de récupérer n'importe quel élément de la pile. Introduisons la notation<br>
<span class=bl>pile_initialement | commande | pile_résultante</span><br>
pour décire la sémantique des commandes. Pour la commande <TT>index</TT> nous aurons :<br>

<TT>...xn...x2 x1 x0 n|index|xm...xn...x2 x1 x0 xn</TT> <p>
Il y en a d'autres, comme <TT>roll, rot</TT> qui modifient la pile cycliquement, le marquage d'une position de la pile et la suppression de tous le éléments jusqu'à la marque, récupération de plusieurs éléments et création d'un tableau avec (c'est comme ça que les procédures sont compilées), etc. Tout est dans la documentation. <p>


<LI> Deux variantes de la commande conditionnelle : <TT>if</TT> et <TT>ifelse</TT>. La première attend sur la pile une valeur boléenne, et une procédure. Cette dernière sera exécutée si la condition est vraie. La commande <TT>ifelse</TT> a naturellement besoin de deux procédures - deux branches de la conditionnelle.
<p>
<li> Relations arithmétiques permettant de prendre les décisions : <TT>gt</TT> (<I>greater than)</I> pour "&gt;" (<TT>a b gt</TT> vérifie a&gt;b); <TT>lt, eq</TT> et <TT>ne</TT> (<I>less than, equal, not_equal</I>). Aussi les relations faibles : <TT>ge, le</TT> (<I>greater_or_equal</I> etc.).

</UL><P>

Voici le code de la procédure qui calcule la valeur absolue de l'objet sur la pile :
<PRE>
/abs {dup 0 lt {-1 mul} if} def
</PRE><P>
et le signe +/- 1 ou zéro d'un nombre :
<PRE>
/sign {dup 0 gt {pop 1} 
                {0 lt {-1} {0} ifelse} 
                ifelse} def
</PRE><P>

<CENTER>
<IMG SRC="../icons/arc_line.gif" WIDTH="475" HEIGHT="11" ALT="">
</CENTER>
<P>

La récursivité marche sans problèmes. Définissons donc la factorielle n!=n*(n-1)!; 0!=1.
<PRE>
/fact {dup 0 eq {pop 1}
                {dup 1 sub fact mul} 
                ifelse} def
</PRE><P>

La solution itérative qui utilise le tampon, écrite en un langage évolué, est déjà connue. Répétons sa définition :
<PRE>
fact n = fc n 1 where
 fc 0 t = t
 fc n t = fc (n-1) (n*t)
</PRE>
ce qui se traduit en PS :
<PRE>
/fact {1 exch fc} def
/fc {dup 0 eq {pop} 
              {exch 1 index mul exch 1 sub fc} 
              ifelse} def
</PRE>
et la pile contient lors de chaque invocation récursive seulement deux objets, le tampon et <TT>n</TT>. Mais PostScript n'optimise pas la récursivité terminale ! La pile des données reste courte, mais la <EM>pile des retours</EM> est gérée comme dans le cas récursif général - on empile les adresses de retour. En "C" (typique) la récursivité terminale n'est pas optimisée non plus, et "accessoirement" les variables locales (arguments) sont également empilés lors de chaque appel, ce quie nous avons pu éviter. Plus tard nous essairons d'optimiser également les retours, notre machine virtuelle sera plus efficace que la machine PS (mais le compilateur sera plus complexe ...)<P>


<!-- ********************************************************* --><p>
<CENTER><IMG SRC="../icons/limarro.gif" WIDTH="576" HEIGHT="9" ALT="">
</CENTER>
<p>

<H3>Intermezzo</H3>

Nous avons discuté les variantes syntaxiques de <B>commentaires</B> utilisées dans de divers langages de programmation. C'est un peu délirant ...
<OL>
<LI> Lisp et Scheme utilisent le point-virgule :<TT>;</TT>.
<LI> Dans un script shell ou Makefile, c'est le dièse : <TT>#</TT>.
<LI> En C nous avons <TT>/* ... */</TT>.
<LI> Accessoirement, en C++ il y a  le commentaire - ligne : <TT>//</TT>.
<LI> En Haskell il y a commentaire-ligne <SUB>--</SUB>,
<li> ... mais également le commentaire imbriqué : <TT>{- ... -}</TT>.
<li> En Pascal - deux variantes <SUB>{ ... }</SUB> et <TT>(* ... *)</TT>. La dernière - aussi en CAML.
<li> En Html : <TT>&lt;!-- ... --&gt;</TT>, mais le contenu balisé par<TT>&lt;script&gt;</TT> est également ignoré par le processus de mise en page (sauf pour les navigateurs obsolètes).
<li> TeX, PostScript, MetaPost, etc., ainsi que quelques autres langages de traitement de textes : le signe de pourcent <TT>%</TT>.
<li> Le feu langage Algol60 utilisait le mot clé <B>comment ... ;</B>
<li> Algol68 permettait l'usage du "cent": <B>¢</B>.
<li> Dans le Lisp pithécanthrope il y avait <B>(comment Belle marquise, 2*2=5)</B>
<li> Chaque assembleur a sa propre convention ... J'ai vu au moins : Le point, point-virgule, étoile et dollar.
<li> Ada? Comme en Haskell (<TT>--</TT>).
<li> REM en Basic. Parfois l'apostrophe '.
<li> La lettre <TT>C</TT> sur la première colonne en Fortran.
</OL><P>

Ceci signifie que les gens qui conçoivent des nouveaux langages de programmation sont pleins d'esprit ...



<!-- ********************************************************* --><p>
<CENTER><IMG SRC="../icons/limarro.gif" WIDTH="576" HEIGHT="9" ALT="">
</CENTER>
<p>

<H3>Approche fonctionnelle au non-déterminisme</H3>
<P>

<EM>Ceci est sujet un peu difficile !</EM><P>

Il s'agit de <I>non-déterminisme logique</I> qui n'a rien à voir avec le hasard. On peut le définir comme : <B>le système traite des questions, auxquelles il existe plusieurs réponses</B>. Exemples :
<UL>
<LI> Un jeu, ou un autre problème de recherche stratégique, ou le "coup suivant" est une entité multiple - l'ensemble de tous les choix individuels.
<LI> Le parsing (analyse syntaxique) d'une règle syntaxique composite, avec alternatives : <br>
<TT>nonterm ::= alternative_1 | alternative_2 | ...</TT>
</UL><P>

On peut aussi imaginer l'application des automates non-déterministes dans plusieurs modèles concrets.<p>

Pour nous, ici, le non-déterminisme sera un <EM>style de raisonnement</EM> : même si on est obligé de créer toutes les possibles branches décisionnelles qui correspondent aux plusieurs choix, on conceptualise le problème comme "si on voulait obtenir <EM>une solution quelconque</EM>".<p>

Ainsi on peut programmer toute une gamme de problèmes "générer-et-tester" (comme les jeux, les solitaires comme le problème de 8 reines, etc.) de manière plus facile pour les humains (et les extra-terrestres normaux). Dans le domaine de compilation les parseurs non-déterministes sont <EM>beaucoup</EM> plus simples, compactes et lisibles que les analyseurs déterministes. Ces derniers évitent les ambiguités par une analyse approfondie du flot des données, et ils sont beaucoup plus efficaces, mais, comme nous avons déjà déclaré : l'essentiel est de comprendre la compilation par la construction de quelques petits modèles réels. Leur efficacité n'est toujours pas très importante, la facilité de codage - <B>si</B>. Plus tard nous aborderons quelques techniques d'optimisation.<p>

Avant de coder notre premier parseur non-déterministe, essayon de comprendre l'essentiel sur les techniques du codage ND. En Prolog le non-déterminisme est mis en relief par l'existence de clauses non-exclusives définissant un prédicat. Par exemple
<PRE>
resultat(5).
resultat(17).
</PRE>
est un prédicat, que - si appelé comme <TT>resultat(X)</TT> peut instancier <TT>X</TT> soit à 5, soit à 17, et <I>a priori</I> on n'a aucun critère de choix. La réalisation technique repose sur la notion de <EM>backtracking</EM>, ou "retour en arrière" : Le module qui appelle le prédicat <TT>resultat</TT> peut ne pas l'accepter, en déclarant l'échec. Le système "oublie" le résultat précédent et en fournit un autre. Ceci se produit jusqu'à l'épuisement du stock. Voici un autre exemple, l'insertion non-déterministe d'un objet dans une liste. On peut le mettre à la tête de la liste, ou garder la tête, et insérer l'objet quelque part plus loin. La définition de ce prédicat est :
<PRE>
insnd(X,L,[X|L]).
insnd(X,[Y|Q],[Y|R]):-insnd(X,Q,R).
</PRE>
La différence entre une fonction à plusieurs clauses en Haskell et ceci, est que les clauses ne sont pas vraiment exclusives. Si on lance l'exécution de ce prédicat et si on demande la répétition en envoyant le caractère ";" ("Ou alors?"), on obtient :
<PRE>
?- insnd(a,[b,c,d,e],R).
R=[a,b,c,d,e];
R=[b,a,c,d,e];
R=[b,c,a,d,e];
R=[b,c,d,a,e];
R=[b,c,d,e,a];
no
</PRE><p>

Nous allons utiliser cette stratégie pour définir une fonction qui calcule toutes les permutations d'une liste, par exemple <TT>perm([a,b,c,d],R).</TT> On doit obtenir
<PRE>
R=[a,b,c,d];
R=[b,a,c,d];
R=[b,c,a,d];
R=[b,c,d,a];
R=[a,c,b,d];
R=[c,a,b,d];
R=[c,b,a,d];
R=[c,b,d,a];
R=[a,c,d,b];
R=[c,a,d,b];
R=[c,d,a,b];
R=[c,d,b,a];
R=[a,b,d,c];
R=[b,a,d,c];
R=[b,d,a,c];
R=[b,d,c,a];
R=[a,d,b,c];
R=[d,a,b,c];
R=[d,b,a,c];
R=[d,b,c,a];
R=[a,d,c,b];
R=[d,a,c,b];
R=[d,c,a,b];
R=[d,c,b,a];
no
</PRE>
et sa définition est
<PRE>
perm([],[]).
perm([X|Q],R):-perm(Q,R1),insnd(X,R1,R).
</PRE>
c'est-à-dire : pour permuter une liste non-vide, on permute sa queue, et on insère la tête originale n'importe où.<p>

Or, Prolog est un langage non-déterministe, où le backtracking est un dispositif système. Grâce à lui on peut écrire des programmes combinatoires de manière très compacte. Peut-on faire une chose pareille avec un langage "classique", déterministe? C'est une question d'implantation. Nous pouvons provisoirement déclarer : le non-déterminisme sera défini comme un moyen de générer <EM>toutes les réponses</EM> à une question ambiguë. 

<a name="defperm">
Maintenant il faut établir une relation entre le concept/style non-déterministe, et sa réalisation dans un langage classique. Essayons d'écrire le programme suivant (<B>erroné</B>, évidemment) : </a>
<PRE style="color: #D00000">
perm [] = []
perm (x:q) = let r1=perm q
             in insnd x r1

insnd x l = (x:l)
insnd x (y:q) = y : (insnd x q)
</PRE>

où la seule modification par rapport à la version Prolog, est le remplacement syntaxique des prédicats par des formes fonctionnelles. Mais les clauses non-contradictoires en Haskell servent à rien. Toujours la première sera choisie.
<p>

Si nous voulons que <TT>insnd</TT> retourne une <EM>liste de réponses</EM>, une réponse non-déterministe qui ici est une liste de listes, les deux clauses sont mauvaises (faute de typage). Commençons à mettre un peu d'ordre dans la définition. D'abord, si on insère un <TT>x</TT> dans la liste vide, le résultat est <TT>[x]</TT>, mais ceci est une solution "classique":, c'est <EM>une</EM> réponse, et non la collection de réponses qui dans ce cas possède un élément. La solution non-déterministe serait <TT>[[x]]</TT>.
<p>

<a name="insnd"> </a>
Ensuite, si l'insertion de <TT>x</TT> dans la queue <TT>q</TT> produit une liste de réponses individuelles, il faut remettre <TT>y</TT> à la tête de chacune. La solution correcte est donc
<PRE>
insnd x [] = [[x]]
insnd x l@(y:q) = (x:l) : map (y:) (insnd x q)
</PRE>
(où la seconde clause est une optimisation légère de :
<PRE style="color: #007000">
insnd x l@(y:q) = [x:l] ++ map (y:) (insnd x q)
</PRE>
Ce qui mérite d'être reconnu est le fait qu'une telle transformation peut être faite presque totalement automatiquement. L'alternative est la concaténation, et l'application d'une fonction normale à un argument non-déterministe, est la distribution de cette fonction par la fonctionnelle <TT>map</TT>. Pour terminer l'exercice il faut répondre à encore une question : comment appliquer un générateur non-déterministe à un argument qui est déjà non-déterministe. Regerdez la <A HREF="#defperm">définition des permutations</A> encore une fois. <p>

Tout d'abord, la permutation de la liste vide n'est pas vide ! La liste vide signifie l'échec, l'absence de solutions. Ici la liste vide qui est <B>la</B> solution, est le seul élément de la collection de réponses.<p>

<a name="mapcon"> </a>

Ensuite, si <TT>r1</TT> est le résultat de l'appel récursif de <TT>perm</TT>, ceci est une liste de réponses. Alors <TT>insnd</TT> ne peut pas être appelée comme ça, le <TT>map</TT> ne suffit pas, car <TT>insnd</TT> est un générateur non-déterministe, et en fin de comptes nous aurons une liste de listes de réponses (ici : une liste de listes de listes). Il faut "aplâtir" cela, construire <B>une</B> réponse non-déterministe, d'une collection de réponses non-déterministes. Il suffit donc d'utiliser la fonction <TT>concat</TT>, déjà connue et qui appartient à la librairie standard. Sa sémantique est simplement
<PRE>
concat [] = []
concat (x:q) = x ++ concat q
</PRE>

Si on veut, on peut optimiser un peu (par déforestation) le programme en introduisant une fonctionnelle "map concaténante":
<PRE>
mapcon f [] = []
mapcon f (x:q) = f x ++ mapcon f xq
</PRE>
mais pour la lisibilité il est préférable de procéder par étapes. La solution finale est
<PRE>
perm [] = [[]]
perm (x:q) = concat (map (insnd x) (perm q))
</PRE>
Nous verrons encore quelques exercices sur le non-déterminisme. Le but de ce volet est triple :
<OL>
<LI>Montrer comment implémenter un langage de programmation qui dispose de non-déterminisme sous forme de <I>data backtracking</I> (gestion de listes de réponses multiples) en utilisant les outils de bord - comment définir sa machine virtuelle (rien de particulier, une machine fonctionnelle), et comment jouer avec sa compilation (exploiter <TT>map</TT> et <TT>concat</TT> insérés là où il faut). Si notre langage de programmation est paresseux, comme Haskell, nous pouvons demander la génération de toutes les permutations de 100 éléments, ce qui naturellement ferait exploser la mémoire gérée par un programme strict. Donc, la paresse se combine bien avec le non-déterminisme, nous pourrons même traiter les cas où le nombre de réponses est illimité.

<LI> Montrer comment gérér les définitions (règles) syntaxiques non-déterministes, comment construire un parseur qui traite correctement les alternatives qui s'enchaînent. Soulignons, que même si un parseur non-déterministe est moins efficace qu'une machine déterministe, il peut être beaucoup plus court et facile à coder.

<LI> Finalement, 
<UL>
	<LI> le non-déterminisme,
	<LI> comme la gestion des erreurs, 
	<LI> et comme l'ajout de la possibilité de <I>tracer</I> l'exécution de notre évaluateur,
	<LI> et comme la transformation CPS avec les <A HREF="comres2.html#contin">continuations</A> -
</UL>
- tout ceci sont des exemples de l'<EM>approche monadique</EM> à la sémantique des langages de programmation. Nous en parlerons un peu plus tard, car le sujet est relativement nouveau, et toujours rarement enseigné, mais il devient le Grand Classique.

</OL>
<p>




<TABLE width=100%>
 <TR><TD align=left><A HREF="comres2.html"><IMG SRC="../icons/gb_larr.gif" border=0 align=absmiddle></A></TD>
<TD align=right><A HREF="comres4.html"><IMG SRC="../icons/gb_rarr.gif" border=0 align=absmiddle></A></TD>
</TR>
</TABLE>
<p>


</FONT>
</BODY>

</HTML>
